--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -3822,13 +5950,32 @@
 	uint32_t lportid;
 	uint32_t fctl;
 	int i;
+	uint16_t qi;
+	uint32_t rex1, rex2;
+	uint8_t temp[64];
 
+	qi = 0;
+
 	qcmd = (qlt_abts_cmd_t *)cmd->cmd_fca_private;
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+		bcopy(qcmd->buf, &temp, IOCB_SIZE);
+		for (i = 0; i < 12; i += 4) {
+			/* Take care of firmware's LE requirement */
+			temp[0x2C+i] = abts->abts_resp_payload[i+3];
+			temp[0x2C+i+1] = abts->abts_resp_payload[i+2];
+			temp[0x2C+i+2] = abts->abts_resp_payload[i+1];
+			temp[0x2C+i+3] = abts->abts_resp_payload[i];
+		}
+		rex1 = QMEM_RD32(qlt, &temp[0x10]);
+		rex2 = QMEM_RD32(qlt, &temp[0x3C]);
+
+		EL(qlt, "req = NULL, %xh %xh %p %xh %xh\n", cmd->cmd_oxid,
+		    cmd->cmd_rportid, cmd, rex1, rex2);
+
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
 	bcopy(qcmd->buf, req, IOCB_SIZE);
@@ -3856,9 +6003,17 @@
 		req[0x2C+i+2] = abts->abts_resp_payload[i+1];
 		req[0x2C+i+3] = abts->abts_resp_payload[i];
 	}
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
 
+	rex1 = QMEM_RD32(qlt, &req[0x10]);
+	rex2 = QMEM_RD32(qlt, &req[0x3C]);
+
+	EL(qlt, "%xh %xh %d %p %xh %xh\n",
+	    QMEM_RD16(qlt, req+0x26), QMEM_RD16(qlt, req+0x24),
+	    terminate, cmd, rex1, rex2);
+
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
+
 	return (FCT_SUCCESS);
 }
 
@@ -3868,12 +6023,19 @@
 	int i;
 	uint32_t d;
 	caddr_t req;
+	uint16_t qi;
+	uint8_t *entry = inot;
+
+	qi = 0;
+
 	/* Just put it on the request queue */
-	mutex_enter(&qlt->req_lock);
-	req = qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
-		/* XXX handle this */
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
+		stmf_trace(qlt->qlt_port_alias,
+		    "qlt_handle_inot: can't get a ReqQ entry");
+		EL(qlt, "req = NULL\n");
 		return;
 	}
 	for (i = 0; i < 16; i++) {
@@ -3884,10 +6046,84 @@
 	}
 	req -= 64;
 	req[0] = 0x0e;
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+
+	QMEM_WR32(qlt, entry+0x3c, 0xdeadbeef);
+	EL(qlt, "Issue inot ack\n");
+
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 }
 
+static uint16_t
+qlt_get_queue_id(qlt_state_t *qlt, int id)
+{
+	uint16_t	qid;
+
+	if ((!qlt->qlt_mq_enabled) || (qlt->qlt_queue_cnt == 1)) {
+		return (0);
+	}
+
+	mutex_enter(&qlt->qlock);
+	if ((id == 0) && (qlt->last_qi == 0)) {
+		qlt->last_qi++;
+	}
+	qid = qlt->last_qi;
+	qlt->last_qi++;
+
+	if (qlt->last_qi >= qlt->qlt_queue_cnt) {
+		qlt->last_qi -= qlt->qlt_queue_cnt;
+	}
+	mutex_exit(&qlt->qlock);
+
+	return (qid);
+}
+
+static fct_status_t
+qlt_verify_atio_entry(qlt_state_t *qlt, uint8_t *atio)
+{
+	uint32_t sig;
+	int i;
+	char info[160];
+
+
+	sig = QMEM_RD32(qlt, atio+0x3c);
+	for (i = 0; ((sig == 0xdeadbeef) &&
+	    (i < qlt_reprocess_attempt_cnt)); i++) {
+		(void) ddi_dma_sync(
+		    qlt->queue_mem_dma_handle,
+		    ATIO_QUEUE_OFFSET + (qlt->atio_ndx_to_fw << 6),
+		    IOCB_SIZE, DDI_DMA_SYNC_FORCPU);
+
+		qlt->qlt_atio_reproc_cnt++;
+		drv_usecwait(qlt_reprocess_delay);
+		sig = QMEM_RD32(qlt, atio+0x3c);
+	}
+
+	if (i) {
+		if (i >= qlt_reprocess_attempt_cnt) {
+			EL(qlt, "atio entry reprocess failed, %x\n",
+			    qlt->qlt_atio_reproc_cnt);
+			cmn_err(CE_WARN, "qlt%d: atio entry reprocess"
+			    " failed %x\n",
+			    qlt->instance, qlt->qlt_atio_reproc_cnt);
+			(void) snprintf(info, 160,
+			    "qlt_handle_ctio_completion: atio entry reprocess"
+			    " failed, %x rsp-%p",
+			    qlt->qlt_atio_reproc_cnt, (void *)atio);
+			info[159] = 0;
+			(void) fct_port_shutdown(qlt->qlt_port,
+			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
+			    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
+			return (QLT_FAILURE);
+		} else {
+			EL(qlt, "atio entry reprocess succeeded, %x %x\n",
+			    i, qlt->qlt_atio_reproc_cnt);
+		}
+	}
+
+	return (QLT_SUCCESS);
+}
+
 uint8_t qlt_task_flags[] = { 1, 3, 2, 1, 4, 0, 1, 1 };
 static void
 qlt_handle_atio(qlt_state_t *qlt, uint8_t *atio)
@@ -3898,8 +6134,12 @@
 	uint32_t	rportid, fw_xchg_addr;
 	uint8_t		*p, *q, *req, tm;
 	uint16_t	cdb_size, flags, oxid;
-	char		info[QLT_INFO_LEN];
+	char		info[160];
+	uint16_t	qi;
 
+	if (qlt_verify_atio_entry(qlt, atio) != QLT_SUCCESS)
+		return;
+
 	/*
 	 * If either bidirection xfer is requested of there is extended
 	 * CDB, atio[0x20 + 11] will be greater than or equal to 3.
@@ -3952,18 +6192,21 @@
 		}
 	}
 	if (cmd == NULL) {
+		qi = 0;	/* just use request queue 0 */
+
 		EL(qlt, "fct_scsi_task_alloc cmd==NULL\n");
 		/* Abort this IO */
 		flags = (uint16_t)(BIT_14 | ((atio[3] & 0xF0) << 5));
 
-		mutex_enter(&qlt->req_lock);
-		req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+		mutex_enter(&qlt->mq_req[qi].mq_lock);
+		req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 		if (req == NULL) {
-			mutex_exit(&qlt->req_lock);
+			mutex_exit(&qlt->mq_req[0].mq_lock);
 
-			(void) snprintf(info, sizeof (info),
+			(void) snprintf(info, 160,
 			    "qlt_handle_atio: qlt-%p, can't "
 			    "allocate space for scsi_task", (void *)qlt);
+			info[159] = 0;
 			(void) fct_port_shutdown(qlt->qlt_port,
 			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 			return;
@@ -3978,16 +6221,111 @@
 		QMEM_WR32(qlt, req+0x14, fw_xchg_addr);
 		QMEM_WR16(qlt, req+0x1A, flags);
 		QMEM_WR16(qlt, req+0x20, oxid);
-		qlt_submit_req_entries(qlt, 1);
-		mutex_exit(&qlt->req_lock);
+		qlt_submit_req_entries(qlt, 1, qi);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 		return;
 	}
+	if (cmd == NULL) {
+		uint32_t res;
+		uint16_t scsi_status = 0;
+		uint16_t rphdl = 0;
 
+		qi = 0; /* always use request queue 0 */
+
+		rphdl = fct_get_rp_handle(qlt->qlt_port, rportid);
+		if ((rphdl != 0xFFFF) &&
+		    (rphdl >= qlt->qlt_port->port_max_logins)) {
+			rphdl = 0xFFFF;
+		}
+
+		mutex_enter(&qlt->mq_req[qi].mq_lock);
+		req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
+		if (req == NULL) {
+			EL(qlt, "cannot get reqq\n");
+			mutex_exit(&qlt->mq_req[qi].mq_lock);
+			(void) snprintf(info, 160,
+			    "qlt_handle_atio: qlt-%p, can't "
+			    "allocate space for termi-excg", (void *)qlt);
+			info[159] = 0;
+			(void) fct_port_shutdown(qlt->qlt_port,
+			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
+			return;
+		}
+
+		if (rphdl != 0xFFFF) {
+			/* Driver send scsi qfull status now */
+			flags = (uint16_t)(BIT_15 |
+			    ((uint16_t)(atio[0x3] & 0xF0) << 5));
+			/* always use SCSI status mode 1 */
+			flags = (uint16_t)(flags | BIT_6);
+
+			scsi_status |= (uint16_t)(0x28);
+
+			/* Build SCSI Status Mode 1, FCP_RSP IU 24-48 byte */
+			bzero(req, IOCB_SIZE);
+			req[0] = 0x12;
+			req[1] = 0x1;
+
+			/* allocate a special IOCB handle? or donot care  */
+			QMEM_WR32(qlt, req+4, 0);
+			QMEM_WR16(qlt, req+8, rphdl);
+			QMEM_WR16(qlt, req+10, 60);
+			QMEM_WR32(qlt, req+0x10, rportid);
+			QMEM_WR32(qlt, req+0x14, fw_xchg_addr);
+
+			/* sense_length set to 0 */
+			QMEM_WR16(qlt, req+0x18, 0);
+
+			QMEM_WR16(qlt, req+0x1A, flags);
+
+			/* Residual transfer length */
+			res = QMEM_RD32(qlt, atio+0x3C);
+			BIG_ENDIAN_32(&res);
+			if (res != 0) {
+				scsi_status |= FCP_RESID_UNDER;
+			}
+			QMEM_WR32_REQ(qlt, qi, req + 0x1C, res);
+
+			QMEM_WR16(qlt, req+0x20, oxid);
+			QMEM_WR16_REQ(qlt, qi, req + 0x22, scsi_status);
+
+			EL(qlt, "Send qfull (%Xh) (%Xh)(%Xh)(%Xh) from port "
+			    "(%Xh:%Xh)\n", scsi_status, fw_xchg_addr, flags,
+			    oxid, rportid, rphdl);
+		} else {
+			/* Terminate exchange because no remote port context */
+			flags = (uint16_t)(BIT_14 | ((atio[3] & 0xF0) << 5));
+
+			bzero(req, IOCB_SIZE);
+			req[0] = 0x12;
+			req[1] = 0x1;
+
+			QMEM_WR32(qlt, req+4, 0);
+			QMEM_WR16(qlt, req+8, rphdl);
+			QMEM_WR16(qlt, req+10, 60);
+			QMEM_WR32(qlt, req+0x10, rportid);
+			QMEM_WR32(qlt, req+0x14, fw_xchg_addr);
+			QMEM_WR16(qlt, req+0x1A, flags);
+			QMEM_WR16(qlt, req+0x20, oxid);
+
+			EL(qlt, "Termi excg (%Xh)(%Xh)(%Xh) from port (%Xh)\n",
+			    fw_xchg_addr, flags, oxid, rportid);
+
+			EL(qlt, "Termi rp_handle (%Xh)\n", rphdl);
+		}
+
+		qlt_submit_req_entries(qlt, 1, qi);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
+		return;
+	}
+
+	qi = qlt_get_queue_id(qlt, 0);
 	task = (scsi_task_t *)cmd->cmd_specific;
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
 	qcmd->fw_xchg_addr = fw_xchg_addr;
 	qcmd->param.atio_byte3 = atio[3];
+	qcmd->qid = qi;
 	cmd->cmd_oxid = oxid;
 	cmd->cmd_rxid = (uint16_t)((((uint16_t)atio[8 + 18]) << 8) |
 	    atio[8+19]);
@@ -4054,6 +6392,8 @@
 		    (((uint32_t)q[1]) << 16) |
 		    (((uint32_t)q[2]) << 8) | q[3];
 	}
+
+	QMEM_WR32(qlt, atio+0x3c, 0xdeadbeef);
 	fct_post_rcvd_cmd(cmd, 0);
 }
 
@@ -4069,7 +6409,11 @@
 	subcode1 = QMEM_RD32(qlt, rsp+0x14);
 	subcode2 = QMEM_RD32(qlt, rsp+0x18);
 
-	mutex_enter(&qlt->preq_lock);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_enter(&qlt->mq_req[0].mq_lock);
+	} else {
+		mutex_enter(&qlt->preq_lock);
+	}
 	if (portid != qlt->rp_id_in_dereg) {
 		int instance = ddi_get_instance(qlt->dip);
 
@@ -4077,7 +6421,11 @@
 		cmn_err(CE_WARN, "qlt(%d): implicit logout completion for 0x%x"
 		    " received when driver wasn't waiting for it",
 		    instance, portid);
-		mutex_exit(&qlt->preq_lock);
+		if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+			mutex_exit(&qlt->mq_req[0].mq_lock);
+		} else {
+			mutex_exit(&qlt->preq_lock);
+		}
 		return;
 	}
 
@@ -4098,7 +6446,11 @@
 		qlt->rp_dereg_status = FCT_SUCCESS;
 	}
 	cv_signal(&qlt->rp_dereg_cv);
-	mutex_exit(&qlt->preq_lock);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_exit(&qlt->mq_req[0].mq_lock);
+	} else {
+		mutex_exit(&qlt->preq_lock);
+	}
 }
 
 /*
@@ -4108,17 +6460,19 @@
 static void
 qlt_handle_unsol_els_completion(qlt_state_t *qlt, uint8_t *rsp)
 {
-	char		info[QLT_INFO_LEN];
+	char		info[160];
 	fct_cmd_t	*cmd;
 	qlt_cmd_t	*qcmd;
 	uint32_t	hndl;
 	uint32_t	subcode1, subcode2;
 	uint16_t	status;
+	uint8_t		elsop;
 
 	hndl = QMEM_RD32(qlt, rsp+4);
 	status = QMEM_RD16(qlt, rsp+8);
 	subcode1 = QMEM_RD32(qlt, rsp+0x24);
 	subcode2 = QMEM_RD32(qlt, rsp+0x28);
+	elsop = rsp[0x16];
 
 	if (!CMD_HANDLE_VALID(hndl)) {
 		EL(qlt, "handle = %xh\n", hndl);
@@ -4127,10 +6481,10 @@
 		 * only happen when abort for an unsol els completes.
 		 * This condition indicates a firmware bug.
 		 */
-		(void) snprintf(info, sizeof (info),
-		    "qlt_handle_unsol_els_completion: "
+		(void) snprintf(info, 160, "qlt_handle_unsol_els_completion: "
 		    "Invalid handle: hndl-%x, status-%x/%x/%x, rsp-%p",
 		    hndl, status, subcode1, subcode2, (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -4155,10 +6509,11 @@
 		/*
 		 * Now why would this happen ???
 		 */
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_unsol_els_completion: can not "
 		    "get cmd, hndl-%x, status-%x, rsp-%p", hndl, status,
 		    (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 
@@ -4186,7 +6541,23 @@
 
 	if (status == 0) {
 		fct_send_response_done(cmd, FCT_SUCCESS, FCT_IOF_FCA_DONE);
+
+		if ((elsop == ELS_OP_LOGO) &&
+		    (qlt->cur_topology == PORT_TOPOLOGY_PT_TO_PT)) {
+			EL(qlt, "reset link since this is LOGO and N2N\n");
+			(void) snprintf(info, 80,
+			    "qlt_handle_unsol_els_completion: qlt-%p, "
+			    "trigger RFLAG_RESET to recover",
+			    (void *)qlt);
+
+			info[79] = 0;
+			(void) fct_port_shutdown(qlt->qlt_port,
+			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET,
+			    info);
+		}
 	} else {
+		EL(qlt, "status (0xh) sucode1=%xh subconde2=%xh\n",
+		    status, subcode1, subcode2);
 		fct_send_response_done(cmd,
 		    QLT_FIRMWARE_ERROR(status, subcode1, subcode2), 0);
 	}
@@ -4195,7 +6566,7 @@
 static void
 qlt_handle_unsol_els_abort_completion(qlt_state_t *qlt, uint8_t *rsp)
 {
-	char		info[QLT_INFO_LEN];
+	char		info[160];
 	fct_cmd_t	*cmd;
 	qlt_cmd_t	*qcmd;
 	uint32_t	hndl;
@@ -4220,10 +6591,11 @@
 			 * There could be exchange resource leakage, so
 			 * throw HBA fatal error event now
 			 */
-			(void) snprintf(info, sizeof (info),
+			(void) snprintf(info, 160,
 			    "qlt_handle_unsol_els_abort_completion: "
 			    "Invalid handle: hndl-%x, status-%x/%x/%x, rsp-%p",
 			    hndl, status, subcode1, subcode2, (void *)rsp);
+			info[159] = 0;
 			(void) fct_port_shutdown(qlt->qlt_port,
 			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 			    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -4239,10 +6611,11 @@
 		/*
 		 * Why would this happen ??
 		 */
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_unsol_els_abort_completion: can not get "
 		    "cmd, hndl-%x, status-%x, rsp-%p", hndl, status,
 		    (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 
@@ -4271,7 +6644,7 @@
 static void
 qlt_handle_sol_els_completion(qlt_state_t *qlt, uint8_t *rsp)
 {
-	char		info[QLT_INFO_LEN];
+	char		info[160];
 	fct_cmd_t	*cmd;
 	fct_els_t	*els;
 	qlt_cmd_t	*qcmd;
@@ -4289,10 +6662,10 @@
 		/*
 		 * This cannot happen for sol els completion.
 		 */
-		(void) snprintf(info, sizeof (info),
-		    "qlt_handle_sol_els_completion: "
+		(void) snprintf(info, 160, "qlt_handle_sol_els_completion: "
 		    "Invalid handle: hndl-%x, status-%x/%x/%x, rsp-%p",
 		    hndl, status, subcode1, subcode2, (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -4302,10 +6675,11 @@
 	cmd = fct_handle_to_cmd(qlt->qlt_port, hndl);
 	if (cmd == NULL) {
 		EL(qlt, "fct_handle_to_cmd cmd==NULL, hndl=%xh\n", hndl);
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_sol_els_completion: can not "
 		    "get cmd, hndl-%x, status-%x, rsp-%p", hndl, status,
 		    (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 
@@ -4351,7 +6725,7 @@
 	qlt_cmd_t	*qcmd;
 	uint32_t	 hndl;
 	uint16_t	 status;
-	char		 info[QLT_INFO_LEN];
+	char		 info[160];
 
 	hndl = QMEM_RD32(qlt, rsp+4);
 	status = QMEM_RD16(qlt, rsp+8);
@@ -4361,9 +6735,9 @@
 		/*
 		 * Solicited commands will always have a valid handle.
 		 */
-		(void) snprintf(info, sizeof (info),
-		    "qlt_handle_ct_completion: "
-		    "hndl-%x, status-%x, rsp-%p", hndl, status, (void *)rsp);
+		(void) snprintf(info, 160, "qlt_handle_ct_completion: hndl-"
+		    "%x, status-%x, rsp-%p", hndl, status, (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -4371,12 +6745,14 @@
 	}
 
 	cmd = fct_handle_to_cmd(qlt->qlt_port, hndl);
+	EL(qlt, "cmd=%ph hndl=%xh status=%xh\n", cmd, hndl, status);
 	if (cmd == NULL) {
 		EL(qlt, "fct_handle_to_cmd cmd==NULL, hndl=%xh\n", hndl);
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_ct_completion: cannot find "
 		    "cmd, hndl-%x, status-%x, rsp-%p", hndl, status,
 		    (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 
@@ -4395,7 +6771,7 @@
 	}
 
 	ASSERT(qcmd->dbuf);
-	if (status == 0) {
+	if ((status == 0) || (status == 0x15)) {
 		qlt_dmem_dma_sync(qcmd->dbuf, DDI_DMA_SYNC_FORKERNEL);
 		bcopy(qcmd->dbuf->db_sglist[0].seg_addr +
 		    qcmd->param.resp_offset,
@@ -4404,7 +6780,7 @@
 	qlt_dmem_free(NULL, qcmd->dbuf);
 	qcmd->dbuf = NULL;
 
-	if (status == 0) {
+	if ((status == 0) || (status == 0x15)) {
 		fct_send_cmd_done(cmd, FCT_SUCCESS, FCT_IOF_FCA_DONE);
 	} else {
 		fct_send_cmd_done(cmd, QLT_FIRMWARE_ERROR(status, 0, 0), 0);
@@ -4411,8 +6787,53 @@
 	}
 }
 
+static fct_status_t
+qlt_verify_resp_entry(qlt_state_t *qlt, uint8_t *rsp, uint16_t qi)
+{
+	uint32_t sig;
+	int i;
+	char info[160];
+
+	sig = QMEM_RD32_RSPQ(qlt, qi, rsp+0x3c);
+	for (i = 0; ((sig == 0xdeadbeef) &&
+	    (i < qlt_reprocess_attempt_cnt)); i++) {
+		(void) ddi_dma_sync(
+		    qlt->mq_resp[qi].queue_mem_mq_dma_handle,
+		    (qlt->mq_resp[qi].mq_ndx_to_fw << 6),
+		    IOCB_SIZE, DDI_DMA_SYNC_FORCPU);
+
+		qlt->qlt_resp_reproc_cnt++;
+		drv_usecwait(qlt_reprocess_delay);
+		sig = QMEM_RD32_RSPQ(qlt, qi, rsp+0x3c);
+	}
+
+	if (i) {
+		if (i >= qlt_reprocess_attempt_cnt) {
+			EL(qlt, "resp entry reprocess failed, %x\n",
+			    qlt->qlt_resp_reproc_cnt);
+			cmn_err(CE_WARN, "qlt%d: resp entry reprocess"
+			    " failed %x\n",
+			    qlt->instance, qlt->qlt_resp_reproc_cnt);
+			(void) snprintf(info, 160,
+			    "qlt_handle_ctio_completion: resp entry reprocess"
+			    " failed, %x rsp-%p",
+			    qlt->qlt_resp_reproc_cnt, (void *)rsp);
+			info[159] = 0;
+			(void) fct_port_shutdown(qlt->qlt_port,
+			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET,
+			    info);
+			return (QLT_FAILURE);
+		} else {
+			EL(qlt, "resp entry reprocess succeeded, %x %x\n",
+			    i, qlt->qlt_resp_reproc_cnt);
+		}
+	}
+
+	return (QLT_SUCCESS);
+}
+
 static void
-qlt_handle_ctio_completion(qlt_state_t *qlt, uint8_t *rsp)
+qlt_handle_ctio_completion(qlt_state_t *qlt, uint8_t *rsp, uint16_t qi)
 {
 	fct_cmd_t	*cmd;
 	scsi_task_t	*task;
@@ -4421,16 +6842,26 @@
 	fct_status_t	fc_st;
 	uint32_t	iof = 0;
 	uint32_t	hndl;
+	uint32_t	rex1;
+	uint16_t	oxid;
 	uint16_t	status;
 	uint16_t	flags;
 	uint8_t		abort_req;
 	uint8_t		n;
-	char		info[QLT_INFO_LEN];
+	char		info[160];
 
+	if (qlt_verify_resp_entry(qlt, rsp, qi) != QLT_SUCCESS)
+		return;
+
+	/* write a deadbeef in the last 4 bytes of the IOCB */
+	QMEM_WR32_RSPQ(qlt, qi, rsp+0x3c, 0xdeadbeef);
+
 	/* XXX: Check validity of the IOCB by checking 4th byte. */
-	hndl = QMEM_RD32(qlt, rsp+4);
-	status = QMEM_RD16(qlt, rsp+8);
-	flags = QMEM_RD16(qlt, rsp+0x1a);
+	hndl = QMEM_RD32_RSPQ(qlt, qi, rsp+4);
+	status = QMEM_RD16_RSPQ(qlt, qi, rsp+8);
+	flags = QMEM_RD16_RSPQ(qlt, qi, rsp+0x1a);
+	oxid = QMEM_RD16_RSPQ(qlt, qi, rsp+0x20);
+	rex1 = QMEM_RD32_RSPQ(qlt, qi, rsp+0x14);
 	n = rsp[2];
 
 	if (!CMD_HANDLE_VALID(hndl)) {
@@ -4444,16 +6875,78 @@
 		    (void *)rsp);
 		if ((status != 1) && (status != 2)) {
 			EL(qlt, "status = %xh\n", status);
-			/*
-			 * There could be exchange resource leakage, so
-			 * throw HBA fatal error event now
-			 */
-			(void) snprintf(info, sizeof (info),
-			    "qlt_handle_ctio_completion: hndl-"
-			    "%x, status-%x, rsp-%p", hndl, status, (void *)rsp);
-			(void) fct_port_shutdown(qlt->qlt_port,
-			    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
+			if (status == 0x29) {
+				uint8_t		*req;
 
+				/*
+				 * The qlt port received an ATIO request from
+				 * remote port before it issued a plogi.
+				 * The qlt fw returned the CTIO completion
+				 * status 0x29 to inform driver to do cleanup
+				 * (terminate the IO exchange). The subsequent
+				 * ABTS from the initiator can be handled
+				 * cleanly.
+				 */
+				qi = 0;
+				mutex_enter(&qlt->mq_req[qi].mq_lock);
+				req = (uint8_t *)
+				    qlt_get_req_entries(qlt, 1, qi);
+
+				if (req == NULL) {
+					EL(qlt, "No reqq entry available to "
+					    "termi exchg\n");
+					mutex_exit(&qlt->mq_req[qi].mq_lock);
+
+					(void) snprintf(info, 160,
+					    "qlt_handle_ctio_completion: no "
+					    "reqq entry available, status-%x,"
+					    "rsp-%p", status, (void *)rsp);
+
+					info[159] = 0;
+
+					(void) fct_port_shutdown(qlt->qlt_port,
+					    STMF_RFLAG_FATAL_ERROR |
+					    STMF_RFLAG_RESET,
+					    info);
+
+					return;
+				}
+
+				flags &= 0x1E00;
+				flags |= BIT_14;
+
+				bzero(req, IOCB_SIZE);
+				req[0] = 0x12;
+				req[1] = 0x1;
+
+				QMEM_WR32(qlt, req+4, 0);
+				QMEM_WR16(qlt, req+8, 0xFFFF);
+				QMEM_WR16(qlt, req+10, 60);
+				QMEM_WR32(qlt, req+0x14, rex1);
+				QMEM_WR16(qlt, req+0x1A, flags);
+				QMEM_WR16(qlt, req+0x20, oxid);
+
+				EL(qlt, "Termi exchg (%Xh)(%Xh)(%Xh) "
+				    "rphdl=0xFFFF\n", rex1, flags, oxid);
+
+				qlt_submit_req_entries(qlt, 1, qi);
+				mutex_exit(&qlt->mq_req[qi].mq_lock);
+			} else {
+				/*
+				 * There could be exchange resource leakage,
+				 * so throw HBA fatal error event now
+				 */
+				(void) snprintf(info, 160,
+				    "qlt_handle_ctio_completion: hndl-%x, "
+				    "status-%x, rsp-%p", hndl, status,
+				    (void *)rsp);
+
+				info[159] = 0;
+
+				(void) fct_port_shutdown(qlt->qlt_port,
+				    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET,
+				    info);
+			}
 		}
 
 		return;
@@ -4470,12 +6963,15 @@
 	cmd = fct_handle_to_cmd(qlt->qlt_port, hndl);
 	if (cmd == NULL) {
 		EL(qlt, "fct_handle_to_cmd cmd==NULL, hndl=%xh\n", hndl);
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_ctio_completion: cannot find "
 		    "cmd, hndl-%x, status-%x, rsp-%p", hndl, status,
 		    (void *)rsp);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
-		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
+		    /* STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info); */
+		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
+		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
 
 		return;
 	}
@@ -4537,12 +7033,17 @@
 	}
 
 	fct_cmd_fca_aborted(cmd, fc_st, iof);
+
+	EL(qlt, "(%d) (%p)(%xh,%xh),%x %x %x\n",
+	    qi, cmd, cmd->cmd_oxid, cmd->cmd_rxid,
+	    cmd->cmd_handle, qcmd->fw_xchg_addr,
+	    fc_st);
 }
 
 static void
 qlt_handle_sol_abort_completion(qlt_state_t *qlt, uint8_t *rsp)
 {
-	char		info[QLT_INFO_LEN];
+	char		info[80];
 	fct_cmd_t	*cmd;
 	qlt_cmd_t	*qcmd;
 	uint32_t	h;
@@ -4556,9 +7057,10 @@
 		/*
 		 * Solicited commands always have a valid handle.
 		 */
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 80,
 		    "qlt_handle_sol_abort_completion: hndl-"
 		    "%x, status-%x, rsp-%p", h, status, (void *)rsp);
+		info[79] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET |
 		    STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
@@ -4570,10 +7072,11 @@
 		/*
 		 * What happened to the cmd ??
 		 */
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 80,
 		    "qlt_handle_sol_abort_completion: cannot "
 		    "find cmd, hndl-%x, status-%x, rsp-%p", h, status,
 		    (void *)rsp);
+		info[79] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 
@@ -4588,6 +7091,7 @@
 		qcmd->dbuf = NULL;
 	}
 	ASSERT(qcmd->flags & QLT_CMD_ABORTING);
+	EL(qlt, "status=%xh\n", status);
 	if (status == 0) {
 		fct_cmd_fca_aborted(cmd, FCT_ABORT_SUCCESS, FCT_IOF_FCA_DONE);
 	} else if (status == 0x31) {
@@ -4598,12 +7102,14 @@
 }
 
 static void
-qlt_handle_rcvd_abts(qlt_state_t *qlt, uint8_t *resp)
+qlt_handle_rcvd_abts(qlt_state_t *qlt, uint8_t *resp, uint16_t qi)
 {
 	qlt_abts_cmd_t	*qcmd;
 	fct_cmd_t	*cmd;
 	uint32_t	remote_portid;
-	char		info[QLT_INFO_LEN];
+	uint32_t	rex1;
+	uint32_t	rex2;
+	char		info[160];
 
 	remote_portid = ((uint32_t)(QMEM_RD16(qlt, (&resp[0x18])))) |
 	    ((uint32_t)(resp[0x1A])) << 16;
@@ -4611,9 +7117,10 @@
 	    sizeof (qlt_abts_cmd_t), 0);
 	if (cmd == NULL) {
 		EL(qlt, "fct_alloc cmd==NULL\n");
-		(void) snprintf(info, sizeof (info),
+		(void) snprintf(info, 160,
 		    "qlt_handle_rcvd_abts: qlt-%p, can't "
 		    "allocate space for fct_cmd", (void *)qlt);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 		return;
@@ -4621,6 +7128,7 @@
 
 	resp[0xC] = resp[0xD] = resp[0xE] = 0;
 	qcmd = (qlt_abts_cmd_t *)cmd->cmd_fca_private;
+	qcmd->qid = qi;
 	bcopy(resp, qcmd->buf, IOCB_SIZE);
 	cmd->cmd_port = qlt->qlt_port;
 	cmd->cmd_rp_handle = QMEM_RD16(qlt, resp+0xA);
@@ -4632,25 +7140,41 @@
 	    ((uint32_t)(resp[0x16])) << 16;
 	cmd->cmd_oxid = QMEM_RD16(qlt, (&resp[0x26]));
 	cmd->cmd_rxid = QMEM_RD16(qlt, (&resp[0x24]));
+
+	rex1 = QMEM_RD32(qlt, resp+0x10);
+	rex2 = QMEM_RD32(qlt, resp+0x3C);
+
+	EL(qlt, "(%d)(%xh %xh) (%xh)(%p) (%xh %xh) (%x)\n",
+	    qi, cmd->cmd_oxid, cmd->cmd_rxid, remote_portid,
+	    cmd, rex1, rex2, cmd->cmd_handle);
+
 	fct_post_rcvd_cmd(cmd, 0);
 }
 
 static void
-qlt_handle_abts_completion(qlt_state_t *qlt, uint8_t *resp)
+qlt_handle_abts_completion(qlt_state_t *qlt, uint8_t *resp, uint16_t qi)
 {
 	uint16_t status;
-	char	info[QLT_INFO_LEN];
+	char	info[80];
 
 	status = QMEM_RD16(qlt, resp+8);
 
 	if ((status == 0) || (status == 5)) {
+		EL(qlt, "qi(%d) status =%xh,(%xh %xh)\n",
+		    qi, status, QMEM_RD16(qlt, resp+0x26),
+		    QMEM_RD16(qlt, resp+0x24));
 		return;
 	}
-	EL(qlt, "status = %xh\n", status);
-	(void) snprintf(info, sizeof (info),
-	    "ABTS completion failed %x/%x/%x resp_off %x",
+
+	EL(qlt, "ABTS status=%x/%x/%x resp_off %x",
+	    status, QMEM_RD32(qlt, resp+0x34),
+	    QMEM_RD32(qlt, resp+0x38),
+	    ((uint32_t)(qlt->mq_resp[0].mq_ndx_to_fw)) << 6);
+
+	(void) snprintf(info, 80, "ABTS completion failed %x/%x/%x resp_off %x",
 	    status, QMEM_RD32(qlt, resp+0x34), QMEM_RD32(qlt, resp+0x38),
-	    ((uint32_t)(qlt->resp_ndx_to_fw)) << 6);
+	    ((uint32_t)(qlt->mq_resp[0].mq_ndx_to_fw)) << 6);
+	info[79] = 0;
 	(void) fct_port_shutdown(qlt->qlt_port, STMF_RFLAG_FATAL_ERROR |
 	    STMF_RFLAG_RESET | STMF_RFLAG_COLLECT_DEBUG_DUMP, info);
 }
@@ -4676,6 +7200,7 @@
 	}
 #endif
 
+	EL(qlt, "cmd_type = %x\n", cmd->cmd_type);
 	if (cmd->cmd_type == FCT_CMD_FCP_XCHG) {
 		return (qlt_abort_unsol_scsi_cmd(qlt, cmd));
 	}
@@ -4685,6 +7210,7 @@
 	}
 
 	if (cmd->cmd_type == FCT_CMD_RCVD_ABTS) {
+		/* this is retried ABTS, terminate it now */
 		return (qlt_send_abts_response(qlt, cmd, 1));
 	}
 
@@ -4696,7 +7222,7 @@
 	    (cmd->cmd_type == FCT_CMD_SOL_CT)) {
 		return (qlt_abort_sol_cmd(qlt, cmd));
 	}
-	EL(qlt, "cmd->cmd_type = %xh\n", cmd->cmd_type);
+	EL(qlt, "cmd->cmd_type = %x\n", cmd->cmd_type);
 
 	ASSERT(0);
 	return (FCT_FAILURE);
@@ -4707,15 +7233,20 @@
 {
 	uint8_t *req;
 	qlt_cmd_t *qcmd;
+	uint16_t qi;
 
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
 	qcmd->flags = (uint16_t)(qcmd->flags | QLT_CMD_ABORTING);
-	EL(qlt, "fctcmd-%p, cmd_handle-%xh\n", cmd, cmd->cmd_handle);
+	qi = qcmd->qid;
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	EL(qlt, "fctcmd-%p, cmd_handle-%xh rportid=%xh\n",
+	    cmd, cmd->cmd_handle, cmd->cmd_rportid);
+
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+		EL(qlt, "req == NULL\n");
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 		return (FCT_BUSY);
 	}
@@ -4730,8 +7261,8 @@
 
 	QMEM_WR32(qlt, req+0xc, cmd->cmd_handle);
 	QMEM_WR32(qlt, req+0x30, cmd->cmd_rportid);
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 	return (FCT_SUCCESS);
 }
@@ -4743,12 +7274,14 @@
 	qlt_cmd_t *qcmd;
 	fct_els_t *els;
 	uint8_t elsop, req1f;
+	uint16_t qi;
 
 	els = (fct_els_t *)cmd->cmd_specific;
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
+	qi = qcmd->qid;
 	elsop = els->els_req_payload[0];
-	EL(qlt, "fctcmd-%p, cmd_handle-%xh, elsop-%xh\n", cmd, cmd->cmd_handle,
-	    elsop);
+	EL(qlt, "fctcmd-%p, cmd_handle-%xh, elsop-%xh\n", cmd,
+	    cmd->cmd_handle, elsop);
 	req1f = 0x60;	/* Terminate xchg */
 	if ((elsop == ELS_OP_PRLI) || (elsop == ELS_OP_PRLO) ||
 	    (elsop == ELS_OP_TPRLO) || (elsop == ELS_OP_LOGO)) {
@@ -4755,11 +7288,11 @@
 		req1f = (uint8_t)(req1f | BIT_4);
 	}
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
-
+		EL(qlt, "req == NULL\n");
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
 
@@ -4778,8 +7311,8 @@
 
 	QMEM_WR32(qlt, (&req[0x10]), qcmd->fw_xchg_addr);
 	QMEM_WR32(qlt, (&req[0x18]), cmd->cmd_rportid);
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 	return (FCT_SUCCESS);
 }
@@ -4790,16 +7323,21 @@
 	qlt_cmd_t *qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
 	uint8_t *req;
 	uint16_t flags;
+	uint16_t qi;
 
+	qi = qcmd->qid;
+
 	flags = (uint16_t)(BIT_14 |
 	    (((uint16_t)qcmd->param.atio_byte3 & 0xf0) << 5));
-	EL(qlt, "fctcmd-%p, cmd_handle-%x\n", cmd, cmd->cmd_handle);
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
-	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+	EL(qlt, "(%d) (%x) (%p) (%x)\n", qi, cmd->cmd_oxid,
+	    cmd, qcmd->fw_xchg_addr);
 
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
+	if (req == NULL) {
+		EL(qlt, "req == NULL\n");
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
 
@@ -4806,15 +7344,15 @@
 	qcmd->flags = (uint16_t)(qcmd->flags | QLT_CMD_ABORTING);
 	bzero(req, IOCB_SIZE);
 	req[0] = 0x12; req[1] = 0x1;
-	QMEM_WR32(qlt, req+4, cmd->cmd_handle);
-	QMEM_WR16(qlt, req+8, cmd->cmd_rp->rp_handle);
-	QMEM_WR16(qlt, req+10, 60);	/* 60 seconds timeout */
-	QMEM_WR32(qlt, req+0x10, cmd->cmd_rportid);
-	QMEM_WR32(qlt, req+0x14, qcmd->fw_xchg_addr);
-	QMEM_WR16(qlt, req+0x1A, flags);
-	QMEM_WR16(qlt, req+0x20, cmd->cmd_oxid);
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	QMEM_WR32_REQ(qlt, qi, req+4, cmd->cmd_handle);
+	QMEM_WR16_REQ(qlt, qi, req+8, cmd->cmd_rp->rp_handle);
+	QMEM_WR16_REQ(qlt, qi, req+10, 60);	/* 60 seconds timeout */
+	QMEM_WR32_REQ(qlt, qi, req+0x10, cmd->cmd_rportid);
+	QMEM_WR32_REQ(qlt, qi, req+0x14, qcmd->fw_xchg_addr);
+	QMEM_WR16_REQ(qlt, qi, req+0x1A, flags);
+	QMEM_WR16_REQ(qlt, qi, req+0x20, cmd->cmd_oxid);
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 	return (FCT_SUCCESS);
 }
@@ -4825,12 +7363,13 @@
 	qlt_state_t *qlt;
 
 	qlt = (qlt_state_t *)cmd->cmd_port->port_fca_private;
+	EL(qlt, "cmd->cmd_type = %xh\n", cmd->cmd_type);
 	if (cmd->cmd_type == FCT_CMD_SOL_ELS) {
 		return (qlt_send_els(qlt, cmd));
 	} else if (cmd->cmd_type == FCT_CMD_SOL_CT) {
 		return (qlt_send_ct(qlt, cmd));
 	}
-	EL(qlt, "cmd->cmd_type = %xh\n", cmd->cmd_type);
+	EL(qlt, "Unknown cmd->cmd_type = %xh\n", cmd->cmd_type);
 
 	ASSERT(0);
 	return (FCT_FAILURE);
@@ -4845,7 +7384,10 @@
 	stmf_data_buf_t *buf;
 	qlt_dmem_bctl_t *bctl;
 	uint32_t sz, minsz;
+	uint16_t qi;
 
+	qi = 0;
+
 	els = (fct_els_t *)cmd->cmd_specific;
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
 	qcmd->flags = QLT_CMD_TYPE_SOLICITED;
@@ -4862,11 +7404,13 @@
 	    els->els_req_size);
 	qlt_dmem_dma_sync(buf, DDI_DMA_SYNC_FORDEV);
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
+		EL(qlt, "req = NULL, %xh %xh %p %xh\n", cmd->cmd_oxid,
+		    cmd->cmd_rportid, cmd, qcmd->fw_xchg_addr);
 		qlt_dmem_free(NULL, buf);
-		mutex_exit(&qlt->req_lock);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
 	bzero(req, IOCB_SIZE);
